
%% load matrix;
load ../MATRICES/lshp1882 ;
A = Problem.A;
%% make it diagonally dominant  to avoid issues
n = size(A,1);
d0 = abs(A)*ones(n,1) -abs(diag(A));
A = spdiags(d0, 0, A);
%%
figure(1);
%% original;
title('Original pattern','fontsize',16);
spy(A) ;
fprintf(1,' original     nnz = %d \n',nnz(A))
pause(2) ;
%%==================== LU - orig.
[L, U] = lu(A);
figure(2) ;
spy(L+U);
title('L and U. No ordering','fontsize',16);
pause(2) ;
n1 = nnz(L)+nnz(U)-n;
fprintf(1,' original LU fill = %d \n',n1)
%%==================== patterm+ rcm
%% reverse cuthill-Mc Kee
q = symrcm(A);
B = A(q,q);
figure(3) 
spy(B);
title('Pattern of A with RCM','fontsize',16);
pause(2) ;
%%==================== LU + rcm
[L, U] = lu(B);
figure(4) 
spy(L+U);
title('LU with RCM','fontsize',16);
n2 = nnz(L)+nnz(U)-n;
fprintf(1,' C M         fill = %d \n',n2)
%%==================== AMD pattern
p = symamd(A);
C = A(p,p);
figure(5)
spy(C);
title('Pattern with AMD ','fontsize',16);
%%==================== LU+ AMD 
pause(2) ;
[L, U] = lu(C);
figure(6) 
spy(L+U);
title('LU with AMD ','fontsize',16);
n3 = nnz(L)+nnz(U)-n;
fprintf(1,' AMD         fill = %d \n',n3)


